--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **                      "Ukady CPLD w praktyce"                        **
-- **                                                                      **
-- **            Module: BCD6DigCnt (przydatny komponent)                  **
-- **            Target device: XILINX CPLD                                **
-- **            Tool versions: ISE WebPACK 9.2i                           **
-- **            Date: BIAYSTOK, stycze 2009                             **
-- **                                                                      **
-- **                     Napisa : Andrzej Pawluczuk                      **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity BCD6DigCnt is port ( Clk : in std_logic ;
                            Reset : in std_logic ;
                            Enable : in std_logic ;
                            Cnt1 : out std_logic_vector ( 3 downto 0 ) ;
                            Cnt10 : out std_logic_vector ( 3 downto 0 ) ;
                            Cnt100 : out std_logic_vector ( 3 downto 0 ) ;
                            Cnt1000 : out std_logic_vector ( 3 downto 0 ) ;
                            Cnt10000 : out std_logic_vector ( 3 downto 0 ) ;
                            Cnt100000 : out std_logic_vector ( 3 downto 0 ) ) ;
end BCD6DigCnt ;

architecture Behavioral of BCD6DigCnt is

  component bcd port ( Clk : in std_logic ;
                       Reset : in std_logic ;
                       Enable : in std_logic ;
                       QOut : out std_logic_vector ( 3 downto 0 ) ) ;
  end component ;

  signal Enable10 : std_logic ;
  signal Enable100 : std_logic ;
  signal Enable1000 : std_logic ;
  signal Enable10000 : std_logic ;
  signal Enable100000 : std_logic ;
  signal LCnt1 : std_logic_vector ( 3 downto 0 ) ;
  signal LCnt10 : std_logic_vector ( 3 downto 0 ) ;
  signal LCnt100 : std_logic_vector ( 3 downto 0 ) ;
  signal LCnt1000 : std_logic_vector ( 3 downto 0 ) ;
  signal LCnt10000 : std_logic_vector ( 3 downto 0 ) ;
  signal LCnt100000 : std_logic_vector ( 3 downto 0 ) ;

begin
  Cnt1 <= LCnt1 ;
  Cnt10 <= LCnt10 ;
  Cnt100 <= LCnt100 ;
  Cnt1000 <= LCnt1000 ;
  Cnt10000 <= LCnt10000 ;
  Cnt100000 <= LCnt100000 ;

  Enable10 <= '1' when ( ( Enable = '1' ) and ( LCnt1 = "1001" ) ) else '0' ;
  Enable100 <= '1' when ( ( Enable10 = '1' ) and ( LCnt10 = "1001" ) ) else '0' ;
  Enable1000 <= '1' when ( ( Enable100 = '1' ) and ( LCnt100 = "1001" ) ) else '0' ;
  Enable10000 <= '1' when ( ( Enable1000 = '1' ) and ( LCnt1000 = "1001" ) ) else '0' ;
  Enable100000 <= '1' when ( ( Enable10000 = '1' ) and ( LCnt10000 = "1001" ) ) else '0' ;

  BCD0Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable ,
                                QOut => LCnt1 ) ;

  BCD1Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable10 ,
                                QOut => LCnt10 ) ;

  BCD2Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable100 ,
                                QOut => LCnt100 ) ;

  BCD3Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable1000 ,
                                QOut => LCnt1000 ) ;

  BCD4Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable10000 ,
                                QOut => LCnt10000 ) ;

  BCD5Instance : bcd port map ( Clk => Clk ,
                                Reset => Reset ,
                                Enable => Enable100000 ,
                                QOut => LCnt100000 ) ;

end Behavioral ;
