--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **                     "Ukady CPLD w praktyce"                         **
-- **                                                                      **
-- **    Project name: Pierwszy                                            **
-- **    Module: Pierwszy (root)                                           **
-- **    Target device: CoolRunner II (XC2C256/TQ144) [DIGILENT]           **
-- **    Tool versions: ISE WebPACK 9.2i                                   **
-- **    Date: BIAYSTOK, stycze 2009                                     **
-- **                                                                      **
-- **                   Napisa : Andrzej Pawluczuk                        **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity Pierwszy is port ( Clk : in std_logic ;
                          Reset : in std_logic ;
                          KeyIn0 : in std_logic ;
                          KeyIn1 : in std_logic ;
                          KeyIn2 : in std_logic ;
                          Seg_A : out std_logic ;
                          Seg_B : out std_logic ;
                          Seg_C : out std_logic ;
                          Seg_D : out std_logic ;
                          Seg_E : out std_logic ;
                          Seg_F : out std_logic ;
                          Seg_G : out std_logic ;
                          Seg_K : out std_logic ;
                          DSel0 : out std_logic ;
                          DSel1 : out std_logic ;
                          DSel2 : out std_logic ;
                          DSel3 : out std_logic ) ;
end Pierwszy ;

architecture Behavioral of Pierwszy is

  signal FDiv : std_logic_vector ( 4 downto 0 ) ;
  signal DClk : std_logic ;
  signal SelCnt : std_logic_vector ( 1 downto 0 ) ;
  signal Segments : std_logic_vector ( 6 downto 0 ) ;
  signal KeyIn : std_logic ;

begin
  FDivInstance : process ( Clk , Reset )
  begin
    if Reset = '0' then
      FDiv <= "00000" ;
    else
      if Clk'event and Clk = '0' then
        FDiv <= FDiv + 1 ;
      end if ;
    end if ;
  end process ;

  DClk <= FDiv ( 4 ) ;

  SelCntInstance : process ( DClk , Reset )
  begin
    if Reset = '0' then
      SelCnt <= "00" ;
    else
      if DClk'event and DClk = '0' then
        SelCnt <= SelCnt + 1 ;
      end if ;
    end if ;
  end process ;

  with SelCnt select
    KeyIn <= '1'    when "11" ,
             KeyIn2 when "10" ,
             KeyIn1 when "01" ,
             KeyIn0 when others ;

  Seg_A <= Segments ( 0 ) ;
  Seg_B <= Segments ( 1 ) ;
  Seg_C <= Segments ( 2 ) ;
  Seg_D <= Segments ( 3 ) ;
  Seg_E <= Segments ( 4 ) ;
  Seg_F <= Segments ( 5 ) ;
  Seg_G <= Segments ( 6 ) ;
  Seg_K <= '1' ;
-- przyporzdkowanie segmentw w Segments
--      0
--     ---  
--  5 |   | 1
--     --- <-- 6
--  4 |   | 2
--     ---
--      3

  with KeyIn select
    Segments <= "0001001" when '1' ,
                "1000111" when others ;

  DSel0 <= '0' when SelCnt = "00" else '1' ;
  DSel1 <= '0' when SelCnt = "01" else '1' ;
  DSel2 <= '0' when SelCnt = "10" else '1' ;
  DSel3 <= '0' when SelCnt = "11" else '1' ;

end Behavioral ;
