--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **                      "Ukady CPLD w praktyce"                        **
-- **                                                                      **
-- **            Module: UHexConv (przydatny komponent)                    **
-- **            Target device: XILINX CPLD                                **
-- **            Tool versions: ISE WebPACK 9.2i                           **
-- **            Date: BIAYSTOK, stycze 2009                             **
-- **                                                                      **
-- **                     Napisa : Andrzej Pawluczuk                      **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity UHexConv is port ( A : in std_logic ;
                          B : in std_logic ;
                          C : in std_logic ;
                          D : in std_logic ;
                          Neg : in std_logic ;
                          Seg_A : out std_logic ;
                          Seg_B : out std_logic ;
                          Seg_C : out std_logic ;
                          Seg_D : out std_logic ;
                          Seg_E : out std_logic ;
                          Seg_F : out std_logic ;
                          Seg_G : out std_logic ) ;
end UHexConv ;

architecture Behavioral of UHexConv is

  signal InpBCD : std_logic_vector ( 3 downto 0 ) ;
  signal Segments : std_logic_vector ( 6 downto 0 ) ;

begin
  InpBCD ( 0 ) <= A ;
  InpBCD ( 1 ) <= B ;
  InpBCD ( 2 ) <= C ;
  InpBCD ( 3 ) <= D ;
  Seg_A <= Neg xor Segments ( 0 ) ;
  Seg_B <= Neg xor Segments ( 1 ) ;
  Seg_C <= Neg xor Segments ( 2 ) ;
  Seg_D <= Neg xor Segments ( 3 ) ;
  Seg_E <= Neg xor Segments ( 4 ) ;
  Seg_F <= Neg xor Segments ( 5 ) ;
  Seg_G <= Neg xor Segments ( 6 ) ;
-- przyporzdkowanie segmentw w Segments
--      0
--     ---  
--  5 |   | 1
--     ---   <- 6
--  4 |   | 2
--     ---
--      3
  with InpBCD select
    Segments <= "1111001" when "0001" ,  --1
                "0100100" when "0010" ,  --2
                "0110000" when "0011" ,  --3
                "0011001" when "0100" ,  --4
                "0010010" when "0101" ,  --5
                "0000010" when "0110" ,  --6
                "1111000" when "0111" ,  --7
                "0000000" when "1000" ,  --8
                "0010000" when "1001" ,  --9
                "0001000" when "1010" ,  --A
                "0000011" when "1011" ,  --b
                "1000110" when "1100" ,  --C
                "0100001" when "1101" ,  --d
                "0000110" when "1110" ,  --E
                "0001110" when "1111" ,  --F
                "1000000" when others ;  --0

end Behavioral ;
